Description

Internal (e.g. when fetching child records), Extbase does not use the Repository provided by an extension but it's own methods (e.g.
findByIdentifier). This leads to Extbase not using QueryCache, not respecting Orderings or other QuerySettings.

If we implement using Repositories instead, this solves all those problems at once.

Related issues:
related to Core - Task # 55169: Extbase: fetch child objects in one query Under Review 2014-07-22
related to Core - Feature # 60460: Refactor lazyLoading handling in extbase Accepted 2014-07-22

History
#1 - 2014-06-28 18:13 - Helmut Hummel

Felix Oertel wrote:

If we implement using Repositories instead, this solves all those problems at once.

What about child records that are not aggregate root, thus do not have a repository of their own?

Instead of implementing kind of a workaround, wouldn't it be more logical to implement proper ordering and caching when using the findByIdentifier()
methods in the persistence manager?

#2 - 2014-06-28 21:30 - Felix Oertel

Hey Helmut,

thanks for your comment.

My idea is to use a generic repository for the domain objects which are not aggregate roots.

I do not think, this solution is a workaround. Implementing a second way to retrieve objects directly (instead of through the repository) looks like a
workaround to me. Why should we implement all we have in repositories (language-/-overlay-mode, ordering, enableFields, settings for storagePid,
queryCache, preparedStatements, etc) a second time?
regards, foertel

#3 - 2014-07-07 21:00 - Lorenz Ulrich

Is there still Work Packages budget left for this task? I completely agree with Felix.

#4 - 2014-07-07 22:20 - Felix Oertel

Hey,

yep, there is some budget left and we are working on this task right now. ;-) Actually having a little two-dayed-codesprint on tue / wed ... expect to see
results after that.

regards, foertel

#5 - 2014-08-20 22:13 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/32286

#6 - 2014-08-20 22:25 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/32286

#7 - 2014-08-20 22:34 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/32286

#8 - 2014-12-23 19:48 - Mathias Schreiber
- Target version changed from 7.0 to 7.1 (Cleanup)

#9 - 2015-03-15 19:33 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/32286

#10 - 2015-06-05 18:41 - Christian Kuhn

The pending patch was abandoned.

#11 - 2015-06-15 17:07 - Benjamin Mack
- Target version changed from 7.1 (Cleanup) to 7.4 (Backend)
